﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="UseGoogleYahooWms.aspx.cs"
    Inherits="CSSamples.UseGoogleYahooWms" %>

<%@ Register Assembly="WebEdition" Namespace="ThinkGeo.MapSuite.WebEdition" TagPrefix="cc1" %>
<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
    <link href="~/theme/default/samplepic/style.css" rel="stylesheet" type="text/css" />
    <title>Use Google/Yahoo/Virtual Earth etc...</title>

    <script type="text/javascript">
        var tgMap = null;
        var basePanel = null;
        var dynamicPanel = null;
        var prefixOfButton = 'OverlayerSwitcher_Input_';
        
        var OnMapCreated = function(map){
            tgMap = map;
            basePanel = $get('basePanel');
            dynamicPanel = $get('dynamicPanel');
            
            var layersInfo = collectLayers(tgMap.layers);
            addOverlays(layersInfo[0], true);
            addOverlays(layersInfo[1], false);
        };
        
        var collectLayers = function(layers){
            var layersInfo = new Array();
            var baseLayers = new Array();
            var dynamicLayers = new Array();
            
            for(var i=0; i<layers.length; i++){
                var layer = layers[i];
                if(layer.isBaseLayer){
                    baseLayers.push(layer);
                }else{
                    dynamicLayers.push(layer);
                }    
            }
            
            layersInfo.push(baseLayers);
            layersInfo.push(dynamicLayers);
            return layersInfo;
        };
        
        var addOverlays = function(layers, isBaseOverlay){
            var panel = isBaseOverlay?basePanel:dynamicPanel;
            if(layers.length == 0){
                panel.style.display = 'none';
            }else{
                for(var i=0; i<layers.length; i++){
                    var layer = layers[i];
                    addOverlay(layer.id, layer.name, (i==0), isBaseOverlay, panel);
                }
            }
        };
        
        function createNamedElement(type, name) {   
           var element = null;   
           // Try the IE way; this fails on standards-compliant browsers   
           try {   
              element = document.createElement('<'+type+' name="'+name+'">');   
           } catch (e) {   
           }   
           if (!element || element.nodeName != type.toUpperCase()) {   
              // Non-IE browser; use canonical method to create named element   
              element = document.createElement(type);   
              element.name = name;   
           }   
           return element;   
       }  
        
        var addOverlay = function(id, name, checked, isBaseOverlay, panel){
                var button = createNamedElement('input', 'BaseOverlay');
                button.id = prefixOfButton + name; 
                button.type = isBaseOverlay?'radio':'checkbox';
                button.name = isBaseOverlay?"BaseOverlays":name;
                button.value = id;
                button.isBaseOverlay = isBaseOverlay;
                button.onclick = function(e){
                    var layerId = this.value;
                    var layer = tgMap.getLayer(layerId);
                    
                    if(this.isBaseOverlay){
                        tgMap.setBaseLayer(layer);
                    }else{
                        layer.display(this.checked);
                    }
                }
                panel.appendChild(button);
                button.checked = checked;
                
                var label = document.createElement('span');
                label.innerHTML = name;
                
                var br = document.createElement('br');
                panel.appendChild(label);
                panel.appendChild(br);
        };
    </script>

</head>
<body>
    <form id="form1" runat="server">
    <asp:ScriptManager ID="Map1_Script" runat="server">
    </asp:ScriptManager>
    <asp:UpdatePanel ID="UpdatePanel1" runat="server">
        <ContentTemplate>
            <cc1:Map ID="Map1" runat="server" Width="100%" Height="100%">
            </cc1:Map>
        </ContentTemplate>
    </asp:UpdatePanel>
    <Description:DescriptionPanel ID="DescPanel" runat="server">
        <div id="basePanel">
            BaseOverlays<br />
        </div>
        <div id="dynamicPanel">
            DynamicOverlays<br />
        </div>
    </Description:DescriptionPanel>
    </form>
</body>
</html>
